package com.adobe.media
{
	public class CubeProjection extends Projection
	{
		public function CubeProjection():void {}
		
		override protected function generateVertices():void 
		{
			// Right->Left->Up->Down->Front->Back
			vertices.push(
			//  x,  y,  z,    u,   v
				1,  1,  -1, 1/3,   0, // Right face of the cube
				1,  1,   1,   0,   0,
				1, -1,   1,   0, 1/2,
				1, -1,  -1, 1/3, 1/2,
			   -1,  1,   1, 2/3,   0, // Left face of the cube
			   -1,  1,  -1, 1/3,   0,
			   -1, -1,  -1, 1/3, 1/2,
			   -1, -1,   1, 2/3, 1/2,
				1,  1,  -1,   1,   0, // Up face of the cube
			   -1,  1,  -1, 2/3,   0,
			   -1,  1,   1, 2/3, 1/2,
			    1,  1,   1,   1, 1/2,
				1, -1,   1, 1/3, 1/2, // Down face of the cube
			   -1, -1,   1,   0, 1/2,
			   -1, -1,  -1,   0,   1,
				1, -1,  -1, 1/3,   1,
			    1,  1,   1, 2/3, 1/2, // Front face of the cube
			   -1,  1,   1, 1/3, 1/2,
			   -1, -1,   1, 1/3,   1,
			    1, -1,   1, 2/3,   1,
			   -1,  1,  -1,   1, 1/2, // Back face of the cube
			    1,  1,  -1, 2/3, 1/2,
			    1, -1,  -1, 2/3,   1,
			   -1, -1,  -1,   1,   1  
			);		
		} 
		
		override protected function generateIndices():void 
		{
			indices.push(
				0,  3,  2,  2,  1,  0, // corresponding indices for right face
				4,  7,  6,  6,  5,  4, // corresponding indices for left face
				8, 11, 10, 10,  9,  8, // corresponding indices for up face
			   12, 15, 14, 14, 13, 12, // corresponding indices for down face
			   16, 19, 18, 18, 17, 16, // corresponding indices for front face
			   20, 23, 22, 22, 21, 20  // corresponding indices for back face
			);
		}
	}
}